//
//	$Revision: #1 $	$Date: 2012/08/03 $
//
//	Copyright (C) Ubiquitous Corp. 2001-2010. All rights reserved.
//
// common header for noe driver and library

#ifndef	__NOE_DRIVER_IF_H__
#define	__NOE_DRIVER_IF_H__	1.01

#ifdef APPS
#include <sys/ioctl.h>
#include <asm/byteorder.h>
#endif /* APPS */

#ifndef SIOCDEVPRIVATE /* linux/sockios.h */
#define SIOCDEVPRIVATE 10
#endif /* SIOCDEVPRIVATE */
#define NOE_READ_IOCTL		(SIOCDEVPRIVATE + 0)
#define NOE_WRITE_IOCTL		(SIOCDEVPRIVATE + 1)
#define NOE_GET_NET_NAME	(SIOCDEVPRIVATE + 2)
#define NOE_DO_SLEEP_MODE	(SIOCDEVPRIVATE + 3)
#define	NOE_GET_NUM_NIF		(SIOCDEVPRIVATE + 4)
/************************** added commands by sony ***************************/
#define NOE_PRE_CLOSE_IOCTL	(SIOCDEVPRIVATE + 5)
#define NOE_INIT_IOCTL	        (SIOCDEVPRIVATE + 6)

#define NOE_IOCTL_ADD_PRIVATE 20  //carefully 

#define NOE_START_SLEEP_MODE   (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 0)
#define NOE_RECEIVE_DO_SLEEP   (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 1)

//DLNA server
#define NOE_READOBJ_SEND_DATA_FROM_HIGHMEM     (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 2)

//HDRL sever
#define NOE_HDRL_SVR_PRE_OPEN_OBJECT   (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 3)
#define NOE_HDRL_SVR_SET_HOST_DATA   (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 6)
#define NOE_HDRL_SVR_POST_CLOSE_OBJECT  (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 7)
#define NOE_HDRL_SVR_CLEAR_HOST_DATA   (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 8)
#define NOE_HDRL_SVR_PRE_CLOSE_OBJECT   (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 9)
#define NOE_HDRL_SVR_STOP_WRITE   (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 10)
#define NOE_HDRL_REC_PAUSE        (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 11)
#define NOE_HDRL_REC_RESTART      (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 12)

//others
#define NOE_GET_PACKET_SIZE_STATUS (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 13)
#define NOE_PRINT_CMD_DATA (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 14)
#define NOE_GET_FLAG_DATA (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 15)
#define NOE_NETWORK_MONITOR_START (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 16)
#define NOE_NETWORK_MONITOR_STOP (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 17)
#define NOE_SET_CHK_STRM_FLAG (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 18)

//maybe unused
#if 0
#define NOE_SET_DLNA_DUMMY_SEND_READOBJECT   (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 19)
#define NOE_SET_DLNA_DUMMY_SEND_WRITEOBJECT_INIT   (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 20)
#define NOE_SET_DLNA_DUMMY_SEND_WRITEOBJECT_DATA   (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 21)
#define NOE_SET_DLNA_DUMMY_SEND_WRITEOBJECT_DONE   (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 22)
#endif

//HDRL sever for HDRL_Move
#define NOE_HDRL_SVR_HIGHMEM_WRITE_UNIT      (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 23)
#define NOE_HDRL_SVR_WAIT_QUEUE_READY        (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 24)
#define NOE_HDRL_SVR_WAIT_UNIT_FILLED        (SIOCDEVPRIVATE + NOE_IOCTL_ADD_PRIVATE + 25)

#define NOE_IOCTL_ADD_PRIVATE_NIF 100  //carefully 
enum {
  NOE_GET_UUID_NIF = NOE_IOCTL_ADD_PRIVATE_NIF,
  NOE_GET_NET_INFO_NIF = NOE_IOCTL_ADD_PRIVATE_NIF+1,
  NOE_SET_NET_INFO_NIF = NOE_IOCTL_ADD_PRIVATE_NIF+2,
  NOE_SEND_MAGIC_PACKET_NIF = NOE_IOCTL_ADD_PRIVATE_NIF+3, //not implemented
  NOE_GET_SYSTEM_NET_INFO_NIF = NOE_IOCTL_ADD_PRIVATE_NIF+4, //not implemented
  NOE_GET_DEVICE_NAME_NIF = NOE_IOCTL_ADD_PRIVATE_NIF+5, //not implemented

  NOE_SET_CURRENT_NIF_WIRED = NOE_IOCTL_ADD_PRIVATE_NIF+6,
  NOE_SET_CURRENT_NIF_BSS = NOE_IOCTL_ADD_PRIVATE_NIF+7,
  NOE_SET_CURRENT_NIF_P2P = NOE_IOCTL_ADD_PRIVATE_NIF+8,
};

#define UUID_SIZE 64
typedef struct {
  NOE_INT32   DeviceID;
  NOE_UCHAR   uuid[UUID_SIZE];
  NOE_UINT32  ret;
} ioctl_get_uuid_t;

#define NET_INFO_SIZE 28
typedef struct {
  NOE_NET_INFO   netinfo[NET_INFO_SIZE];
  NOE_UINT32     ret;
} ioctl_get_net_info_t;

typedef struct {
  NOE_UINT32     num_netinfo;
  NOE_NET_INFO   netinfo[NET_INFO_SIZE];
  NOE_UINT32     ret;
} ioctl_set_net_info_t;

//#define NOE_IO_DEVICE	"/dev/usb/noe0" /* if linux 2.4.22 */
#define NOE_IO_DEVICE	"/dev/noe0" /* if linux 2.6.20 */

#define HOST_DRIVER_MAXPAYLOAD	(64*1024)
#define HOST_DRIVER_MAXPACKET	(HOST_DRIVER_MAXPAYLOAD+256)
#define HOST_FRAMESIZE		HOST_DRIVER_MAXPACKET


//NOE_READ_IOCTL packet format
typedef struct {
	NOE_HEADER	h;
	NOE_UINT8	*payload;
						// payload must be multiple of 4
} NOE_pFRAME;

//byte order macro define
#ifndef SUBSYSTEM_BYTE_ORDER_BIGENDIAN
#define SUBSYSTEM_BYTE_ORDER_BIGENDIAN 1 //Subsystem byte order [ex. SH-2]
#endif

#ifdef __KERNEL__

#if SUBSYSTEM_BYTE_ORDER_BIGENDIAN
//host -> subsystem[be] case
 #define host2sub64	__cpu_to_be64
 #define host2sub32	__cpu_to_be32
 #define host2sub16	__cpu_to_be16
 #define sub2host64	__be64_to_cpu
 #define sub2host32	__be32_to_cpu
 #define sub2host16	__be16_to_cpu

 #define host2sub64p(p)	__cpu_to_be64p((__u64 *)p)
 #define host2sub32p(p)	__cpu_to_be32p((__u32 *)p)
 #define host2sub16p(p)	__cpu_to_be16p((__u16 *)p)
 #define sub2host64p(p)	__be64_to_cpup((__u64 *)p)
 #define sub2host32p(p)	__be32_to_cpup((__u32 *)p)
 #define sub2host16p(p)	__be16_to_cpup((__u16 *)p)

#else /* SUBSYSTEM_BYTE_ORDER_BIGENDIAN == 0 */
//host -> subsystem[le] case
 #define host2sub64	cpu_to_le64
 #define host2sub32	cpu_to_le32
 #define host2sub16	cpu_to_le16
 #define sub2host64	le64_to_cpu
 #define sub2host32	le32_to_cpu
 #define sub2host16	le16_to_cpu

 #define host2sub64p(p)	cpu_to_le64p((__u64 *)p)
 #define host2sub32p(p)	cpu_to_le32p((__u32 *)p)
 #define host2sub16p(p)	cpu_to_le16p((__u16 *)p)
 #define sub2host64p(p)	le64_to_cpup((__u64 *)p)
 #define sub2host32p(p)	le32_to_cpup((__u32 *)p)
 #define sub2host16p(p)	le16_to_cpup((__u16 *)p)
#endif /* SUBSYSTEM_BYTE_ORDER_BIGENDIAN == 0 */

#else /* __KERNEL */

#if SUBSYSTEM_BYTE_ORDER_BIGENDIAN
//host -> subsystem[be] case
 #define host2sub64	
 #define host2sub32	
 #define host2sub16	
 #define sub2host64	
 #define sub2host32	
 #define sub2host16	

 #define host2sub64p(p)	__cpu_to_be64p((__u64 *)p)
 #define host2sub32p(p)	__cpu_to_be32p((__u32 *)p)
 #define host2sub16p(p)	__cpu_to_be16p((__u16 *)p)
 #define sub2host64p(p)	__be64_to_cpup((__u64 *)p)
 #define sub2host32p(p)	__be32_to_cpup((__u32 *)p)
 #define sub2host16p(p)	__be16_to_cpup((__u16 *)p)

#else /* SUBSYSTEM_BYTE_ORDER_BIGENDIAN == 0 */
#error not-supported
#endif

#endif /* __KERNEL__ */

#define	NOEhi_htos16(x)	host2sub16(x)
#define	NOEhi_htos32(x)	host2sub32(x)
#define	NOEhi_stoh16(x)	sub2host16(x)
#define	NOEhi_stoh32(x)	sub2host32(x)
#define	NOEhi_htos64(x)	host2sub64(x)
#define	NOEhi_stoh64(x)	sub2host64(x)

#define	NOEhi_GET_UINT16(p, v)	do {\
					(v) = (NOE_UINT16)NOEhi_stoh16(*(NOE_UINT16 *)(p));\
					(p) = (void *)((NOE_UINT8 *)(p) + sizeof(NOE_UINT16));\
				} while(0)
#define	NOEhi_GET_UINT32(p, v)	do {\
					(v) = (NOE_UINT32)NOEhi_stoh32(*(NOE_UINT32 *)(p));\
					(p) = (void *)((NOE_UINT8 *)(p) + sizeof(NOE_UINT32));\
				} while(0)
#define	NOEhi_GET_INT32(p, v)	do {\
					(v) = (NOE_INT32)NOEhi_stoh32(*(NOE_UINT32 *)(p));\
					(p) = (void *)((NOE_UINT8 *)(p) + sizeof(NOE_INT32));\
				} while(0)
#define	NOEhi_GET_UINT64(p, v)	do {\
					(v) = (NOE_UINT64)NOEhi_stoh64(*(NOE_UINT64 *)(p));\
					(p) = (void *)((NOE_UINT8 *)(p) + sizeof(NOE_UINT64));\
				} while(0)
#define	NOEhi_GET_INT64(p, v)	do {\
					(v) = (NOE_INT64)NOEhi_stoh64(*(NOE_UINT64 *)(p));\
					(p) = (void *)((NOE_UINT8 *)(p) + sizeof(NOE_INT64));\
				} while(0)

#define	NOEhi_SET_16(p, v)	do {\
					*(NOE_UINT16 *)p = NOEhi_htos16(v);\
					p += sizeof(NOE_UINT16);\
				} while(0)

#define	NOEhi_SET_32(p, v)	do {\
					*(NOE_UINT32 *)p = NOEhi_htos32(v);\
					p += sizeof(NOE_UINT32);\
				} while(0)

#define	NOEhi_SET_64(p, v) 	do {\
					*(NOE_UINT64 *)p = NOEhi_htos64(v);\
					p += sizeof(NOE_UINT64);\
				} while(0)

#define	NOEhi_STORE_32(p, v)	do {\
					*(NOE_UINT32 *)p = NOEhi_htos32(v);\
				} while(0)

#define	NOEhi_SKIP_STREAM(p, l)	((void *)((NOE_UINT8 *)(p) + (l)))

#define	NOEhi_GET_STRING_PTR(p, s) do {\
					NOE_INT32	l;\
					NOEhi_GET_INT32(p, l);\
					(s) = (NOE_UCHAR *)(p);\
					(p) = NOEhi_SKIP_STREAM(p, NOE_MAKEALIGN(l));\
				} while(0)

#define	NOEhi_SET_STRING(p, str) do {\
					int	l;\
					l = NOEhi_STRING_BODYLEN(str);\
					NOEhi_SET_32((p), l);\
					if(l) {\
						memcpy((p), (str), l);\
						(p) = (p) + NOE_MAKEALIGN(l);\
					}\
				} while(0)

#define	NOEhi_GET_MEM_NA(d, s, l) do {\
					memcpy((d), (s), l);\
					(s) = (void *)((NOE_UCHAR *)(s) + (l));\
				} while(0)
#define	NOEhi_GET_MEM(d, s, l) do {\
					memcpy((d), (s), l);\
					(s) = (void *)((NOE_UCHAR *)(s) + NOE_MAKEALIGN(l));\
				} while(0)
#define	NOEhi_SET_MEM_NA(d, s, l) do {\
					memcpy((d), (s), l);\
					(d) = (void *)((NOE_UINT8 *)(d) + (l));\
				} while(0)
#define	NOEhi_SET_MEM(d, s, l) do {\
					memcpy((d), (s), l);\
					(d) = (void *)((NOE_UINT8 *)(d) + NOE_MAKEALIGN(l));\
				} while(0)
#define	NOEhi_MEMCOPY	NOEhi_SET_MEM

#define	NOEhi_GET_BULK_DATA_PTR(p, s, l) do {\
					(s) = (NOE_UCHAR *)(p);\
					(p) = NOEhi_SKIP_STREAM(p, NOE_MAKEALIGN(l));\
				} while(0)

#define	NOEhi_GET_STRING_PTR_WITH_NULL_CHECK(p, s) do {\
					NOE_INT32	l;\
					NOEhi_GET_INT32(p, l);\
					if (l == 0) \
						(s) = (NOE_UCHAR *)NULL;\
					else \
						(s) = (NOE_UCHAR *)(p);\
					(p) = NOEhi_SKIP_STREAM(p, NOE_MAKEALIGN(l));\
				} while(0)

static inline int
NOEhi_STRING_BODYLEN(NOE_UCHAR *str)
{
	if(str == NULL)
		return(0);

	return(strlen((char *)str) + 1);
}
#define	NOEhi_STRINGLEN(str)	(NOEhi_STRING_BODYLEN(str) + sizeof(NOE_UINT32))
//#endif

/***************************************************/
/*               added by SONY                     */
/***************************************************/
#define NFE_MULTI_PACKET_MODE

#ifdef NFE_MULTI_PACKET_MODE

#define NFE_MULTI_PACKET_FRAME_SIZE   1532

#define NFE_DEFAULT_MULTI_PACKET_CNT  1
#define NFE_MAX_MULTI_PACKET_CNT      32

#else /*NFE_MULTI_PACKET_MODE*/
#define NFE_MAX_PAYLOAD_SIZE          1600
#define DEVICE_MAX_PACKET_SIZE        NFE_MAX_PAYLOAD_SIZE+32 /* 32 is NOE_HEADER */
#define NFE_NET_DRIVER_MAXPACKET      DEVICE_MAX_PACKET_SIZE

#define NFE_USB_DRIVER_BUFSIZE        DEVICE_MAX_PACKET_SIZE
#endif /*NFE_MULTI_PACKET_MODE*/


#endif	/*__NOE_DRIVER_IF_H__ */
