/*
 * usb_drv driver -
 *
 *  Copyright 2009 Sony Corporation.
 *  Copyright (C) Ubiquitous Corp. 2001-2009. All rights reserved.
 *  Copyright (C) 2001-2004 Greg Kroah-Hartman (greg@kroah.com)
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License as
 *	published by the Free Software Foundation, version 2.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This driver is based on the 2.6.3 version of drivers/usb/usb-skeleton.c
 * but has been rewritten to be easier to read and use.
 *
 */
#ifndef __NOE_DRV_CONFIG_H__
#define __NOE_DRV_CONFIG_H__

//
// noe usb driver configuration 
//

/* Define these values to match your devices */
#define USB_VENDOR_ID	0xffff
#define USB_PRODUCT_ID	0x0003
#define	NET_PRODUCT_ID	0x0004
#if defined(MULTI_NIF)
#define	NOE_PRODUCT_ID	0x0004
#else
#define NOE_PRODUCT_ID	0x0004
#endif
#define	USB_PRODUCT_VER	0x0100



//Vender Specific Request
#define LINK_ON	1
#define LINK_OFF 0
enum eth_request {
	get_Mac_Address = 0,
	get_Link_Status = 1,
	get_Num_NIF = 2,
	set_Net_Stats_Period = 3,
};


#endif	// __NOE_DRV_CONFIG_H__
